Index: /XIOS/dev/branch_yushan_merged/inputs/REMAP/iodef.xml
===================================================================
--- /XIOS/dev/branch_yushan_merged/inputs/REMAP/iodef.xml	(revision 1178)
+++ /XIOS/dev/branch_yushan_merged/inputs/REMAP/iodef.xml	(revision 1179)
@@ -35,15 +35,15 @@
    <file_definition type="one_file" par_access="collective" output_freq="1ts" output_level="10" enabled=".TRUE.">
       
-      <file_group id="read_then_write_files" enabled=".FALSE.">
+      <file_group id="read_then_write_files" enabled=".TRUE.">
        <file id="output_regular_pole" name="output_dst_regular" >
-          <field field_ref="tmp_field_0" name="field_regular_0" enabled=".FALSE."/>
-          <field field_ref="dst_field_regular" name="field_regular" enabled=".FALSE."/>
-          <field field_ref="dst_field_regular_pole_0" name="field_regular_pole_0" enabled=".FALSE." />
+          <field field_ref="tmp_field_0" name="field_regular_0" enabled=".TRUE."/>
+          <field field_ref="dst_field_regular" name="field_regular" enabled=".TRUE."/>
+          <field field_ref="dst_field_regular_pole_0" name="field_regular_pole_0" enabled=".TRUE." />
           <field field_ref="dst_field_regular_pole_1" name="field_regular_pole_1" enabled=".FALSE." />
        </file>
-       <file id="output_dst_curvilinear" name="output_dst_curvilinear" enabled=".FALSE." >
+       <file id="output_dst_curvilinear" name="output_dst_curvilinear" enabled=".TRUE." >
           <field field_ref="tmp_field_1" operation="instant"/>
        </file>
-       <file id="output_dst_unstructured" name="output_dst_unstructured" enabled=".FALSE." >
+       <file id="output_dst_unstructured" name="output_dst_unstructured" enabled=".TRUE." >
           <field field_ref="tmp_field_2" operation="instant"/>
        </file>
@@ -52,13 +52,13 @@
       <file_group id="write_files" >
         <file id="output_2D" name="output_2D" enabled=".TRUE.">
-          <field field_ref="src_field_2D" name="field_src" enabled=".FALSE."/>
-          <field field_ref="src_field_2D_clone" name="field_src_clone" default_value="100000" enabled=".FALSE."/>
+          <field field_ref="src_field_2D" name="field_src" enabled=".TRUE."/>
+          <field field_ref="src_field_2D_clone" name="field_src_clone" default_value="100000" enabled=".TRUE."/>
           <field field_ref="src_field_2D" name="field_dst_regular_0"  domain_ref="dst_domain_regular_pole" enabled=".TRUE."/>
-          <field field_ref="dst_field_2D" name="field_dst_regular_1" enabled=".FALSE." />
-          <field field_ref="dst_field_2D_regular_pole" name="field_dst_regular_2" enabled=".FALSE."/>
-          <field field_ref="dst_field_2D_clone" name="field_dst_regular_3" detect_missing_value=".false." default_value="100000" enabled=".FALSE."/>
-          <field field_ref="dst_field_2D_extract" name="field_dst_regular_4" enabled=".FALSE."/>
+          <field field_ref="dst_field_2D" name="field_dst_regular_1" enabled=".TRUE." />
+          <field field_ref="dst_field_2D_regular_pole" name="field_dst_regular_2" enabled=".TRUE."/>
+          <field field_ref="dst_field_2D_clone" name="field_dst_regular_3" detect_missing_value=".false." default_value="100000" enabled=".TRUE."/>
+          <field field_ref="dst_field_2D_extract" name="field_dst_regular_4" enabled=".TRUE."/>
         </file> 
-       <file id="output_3D" name="output_3D" enabled=".FALSE.">
+       <file id="output_3D" name="output_3D" enabled=".TRUE.">
           <field field_ref="src_field_3D" name="field_src" />
           <field field_ref="src_field_3D_pression" name="field" />
@@ -66,6 +66,6 @@
           <field field_ref="dst_field_3D_interp" name="field_dst_interp_domain_axis" domain_ref="dst_domain_regular_pole"/>  
        </file>
-       <file id="output_4D" name="output_4D" enabled=".FALSE.">
-          <field field_ref="src_field_4D" name="field_4D" enabled=".FALSE."/>
+       <file id="output_4D" name="output_4D" enabled=".TRUE.">
+          <field field_ref="src_field_4D" name="field_4D" />
           <field field_ref="dst_field_4D_extract" name="field_4D_extract" />
         </file>
Index: /XIOS/dev/branch_yushan_merged/inputs/Unstruct/iodef.xml
===================================================================
--- /XIOS/dev/branch_yushan_merged/inputs/Unstruct/iodef.xml	(revision 1178)
+++ /XIOS/dev/branch_yushan_merged/inputs/Unstruct/iodef.xml	(revision 1179)
@@ -16,10 +16,11 @@
         <field field_ref="field_A_srf" name="field_A"/>
         <field field_ref="field_A_srf" name="field_rect" grid_ref="grid_rect"/>
- <!--       <field field_ref="field_A_srf" name="field_curv" grid_ref="grid_curv"/> -->
+        <field field_ref="field_A_srf" name="field_rect2" grid_ref="grid_rect2"/>
+      <!--  <field field_ref="field_A_srf" name="field_curv" grid_ref="grid_curv"/> -->
      </file>
 
- <!--    <file id="output_src_curvilinear" name="output_src_curvilinear" mode="read" >
-          <field id="src_field_curvilinear" name="field_A" grid_ref="src_grid_curvilinear_read" operation="instant"/>
-     </file>  -->
+     <!-- <file id="output_src_curvilinear" name="output_src_curvilinear" mode="read" >
+       <field id="src_field_curvilinear" name="field_A" grid_ref="src_grid_curvilinear_read" operation="instant"/>
+     </file> --> 
  
    </file_definition>
@@ -40,4 +41,9 @@
      <domain id="dst_domain_regular_pole" ni_glo="90" nj_glo="45" type="rectilinear">
        <generate_rectilinear_domain id="domain_regular_pole"/>
+       <interpolate_domain write_weight="false" order="1" renormalize="true"/>       
+     </domain>
+
+     <domain id="dst_domain_regular_pole2" ni_glo="90" nj_glo="90" type="rectilinear">
+       <generate_rectilinear_domain id="domain_regular_pole2"/>
        <interpolate_domain write_weight="false" order="1" renormalize="true"/>       
      </domain>
@@ -62,4 +68,9 @@
      <grid id="grid_rect">
        <domain domain_ref="dst_domain_regular_pole" />
+       <axis axis_ref="axis_srf" />
+     </grid>
+
+     <grid id="grid_rect2">
+       <domain domain_ref="dst_domain_regular_pole2" />
        <axis axis_ref="axis_srf" />
      </grid>
Index: /XIOS/dev/branch_yushan_merged/src/buffer_client.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/buffer_client.cpp	(revision 1178)
+++ /XIOS/dev/branch_yushan_merged/src/buffer_client.cpp	(revision 1179)
@@ -88,5 +88,4 @@
       {
         MPI_Issend(buffer[current], count, MPI_CHAR, serverRank, 20, interComm, &request);
-        #pragma omp critical (_output)
         pending = true;
         if (current == 1) current = 0;
Index: /XIOS/dev/branch_yushan_merged/src/client.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/client.cpp	(revision 1178)
+++ /XIOS/dev/branch_yushan_merged/src/client.cpp	(revision 1179)
@@ -107,10 +107,10 @@
             MPI_Comm_rank(intraComm,&intraCommRank) ;
             
-            /*#pragma omp critical(_output)
+            #pragma omp critical(_output)
             {
               info(10)<<"intercommCreate::client "<<test_omp_rank<< " "<< &test_omp_rank <<" intraCommSize : "<<intraCommSize
                  <<" intraCommRank :"<<intraCommRank<<"  serverLeader "<< serverLeader
                  <<" globalComm : "<< &(CXios::globalComm) << endl ;  
-            }*/
+            }
 
             
Index: /XIOS/dev/branch_yushan_merged/src/context_server.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/context_server.cpp	(revision 1178)
+++ /XIOS/dev/branch_yushan_merged/src/context_server.cpp	(revision 1179)
@@ -82,5 +82,5 @@
         ep_lib::MPI_Iprobe(rank,20,interComm,&flag,&status);
         traceOn();
-        if (flag==true)
+        if (flag)
         {
           it=buffers.find(rank);
Index: /XIOS/dev/branch_yushan_merged/src/test/test_remap_omp.f90
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/test/test_remap_omp.f90	(revision 1178)
+++ /XIOS/dev/branch_yushan_merged/src/test/test_remap_omp.f90	(revision 1179)
@@ -52,5 +52,5 @@
   if(rank < size-2) then
 
-  !$omp parallel default(private) firstprivate(dtime)
+  !$omp parallel default(firstprivate) firstprivate(dtime)
 
 !!! XIOS Initialization (get the local communicator)
@@ -232,16 +232,16 @@
     CALL xios_send_field("src_field_2D",src_field_2D)
     
-    DO i=1,src_ni
-      src_field_2D_clone(i) = src_field_2D(i)
-      IF ((23.5 * ts < src_lat(i)) .AND. (src_lat(i) < 65.5 *ts) .AND. (0 < src_lon(i)) .AND. (src_lon(i) < 30*ts)) THEN      
-        src_field_2D_clone(i) = missing_value    
-      ENDIF
-    ENDDO
-
-    CALL xios_send_field("src_field_2D_clone",src_field_2D_clone)
-    CALL xios_send_field("src_field_3D",src_field_3D)
-    CALL xios_send_field("src_field_3D_clone",src_field_3D)
-    CALL xios_send_field("src_field_4D",src_field_4D)
-    CALL xios_send_field("src_field_3D_pression",src_field_pression)
+    !DO i=1,src_ni
+    !  src_field_2D_clone(i) = src_field_2D(i)
+    !  IF ((23.5 * ts < src_lat(i)) .AND. (src_lat(i) < 65.5 *ts) .AND. (0 < src_lon(i)) .AND. (src_lon(i) < 30*ts)) THEN      
+    !    src_field_2D_clone(i) = missing_value    
+    !  ENDIF
+    !ENDDO
+
+    !CALL xios_send_field("src_field_2D_clone",src_field_2D_clone)
+    !CALL xios_send_field("src_field_3D",src_field_3D)
+    !CALL xios_send_field("src_field_3D_clone",src_field_3D)
+    !CALL xios_send_field("src_field_4D",src_field_4D)
+    !CALL xios_send_field("src_field_3D_pression",src_field_pression)
     CALL xios_send_field("tmp_field_0",tmp_field_0)
     CALL xios_send_field("tmp_field_1",tmp_field_1)
@@ -258,5 +258,5 @@
   CALL xios_finalize()
   
-  print *, "Client : xios_finalize "
+  print *, "Client : xios_finalize ", rank
 
   !$omp barrier