Index: XIOS/dev/branch_yushan_merged/src/test/test_remap_omp.f90
===================================================================
--- XIOS/dev/branch_yushan_merged/src/test/test_remap_omp.f90	(revision 1196)
+++ XIOS/dev/branch_yushan_merged/src/test/test_remap_omp.f90	(revision 1203)
@@ -183,5 +183,13 @@
   ierr=NF90_GET_VAR(ncid,varid, dst_boundslat, start=(/1,dst_ibegin+1/),count=(/dst_nvertex,dst_ni/))
 
-
+   !$omp barrier
+
+  !$omp master 
+  CALL MPI_barrier(comm, ierr)
+  !$omp end master
+
+  !$omp barrier
+
+  
   CALL xios_context_initialize("test",comm)
   CALL xios_get_handle("test",ctx_hdl)
@@ -214,17 +222,17 @@
   CALL xios_close_context_definition()
 
-  CALL xios_get_domain_attr("src_domain_regular_read", ni=src_tmp_ni, nj=src_tmp_nj)
-  ALLOCATE(tmp_field_0(src_tmp_ni*src_tmp_nj))
-
-  CALL xios_get_axis_attr("src_axis_curvilinear_read", n=src_tmp_n)
-  CALL xios_get_domain_attr("src_domain_curvilinear_read", ni=src_tmp_ni, nj=src_tmp_nj)
-  ALLOCATE(tmp_field_1(src_tmp_ni*src_tmp_nj*src_tmp_n))
-
-  CALL xios_get_domain_attr("src_domain_unstructured_read", ni=src_tmp_ni, nj=src_tmp_nj)
-  ALLOCATE(tmp_field_2(src_tmp_ni*src_tmp_nj))
-  
-  CALL xios_recv_field("src_field_regular", tmp_field_0)
-  CALL xios_recv_field("src_field_curvilinear", tmp_field_1)
-  CALL xios_recv_field("src_field_unstructured", tmp_field_2)
+!  CALL xios_get_domain_attr("src_domain_regular_read", ni=src_tmp_ni, nj=src_tmp_nj)
+!  ALLOCATE(tmp_field_0(src_tmp_ni*src_tmp_nj))
+
+!  CALL xios_get_axis_attr("src_axis_curvilinear_read", n=src_tmp_n)
+!  CALL xios_get_domain_attr("src_domain_curvilinear_read", ni=src_tmp_ni, nj=src_tmp_nj)
+!  ALLOCATE(tmp_field_1(src_tmp_ni*src_tmp_nj*src_tmp_n))
+
+!  CALL xios_get_domain_attr("src_domain_unstructured_read", ni=src_tmp_ni, nj=src_tmp_nj)
+!  ALLOCATE(tmp_field_2(src_tmp_ni*src_tmp_nj))
+  
+!  CALL xios_recv_field("src_field_regular", tmp_field_0)
+!  CALL xios_recv_field("src_field_curvilinear", tmp_field_1)
+!  CALL xios_recv_field("src_field_unstructured", tmp_field_2)
 
   DO ts=1,10
@@ -232,19 +240,19 @@
     CALL xios_send_field("src_field_2D",src_field_2D)
     
-    !DO i=1,src_ni
-    !  src_field_2D_clone(i) = src_field_2D(i)
-    !  IF ((23.5 * ts < src_lat(i)) .AND. (src_lat(i) < 65.5 *ts) .AND. (0 < src_lon(i)) .AND. (src_lon(i) < 30*ts)) THEN      
-    !    src_field_2D_clone(i) = missing_value    
-    !  ENDIF
-    !ENDDO
-
-    !CALL xios_send_field("src_field_2D_clone",src_field_2D_clone)
-    !CALL xios_send_field("src_field_3D",src_field_3D)
-    !CALL xios_send_field("src_field_3D_clone",src_field_3D)
-    !CALL xios_send_field("src_field_4D",src_field_4D)
-    !CALL xios_send_field("src_field_3D_pression",src_field_pression)
-    CALL xios_send_field("tmp_field_0",tmp_field_0)
-    CALL xios_send_field("tmp_field_1",tmp_field_1)
-    CALL xios_send_field("tmp_field_2",tmp_field_2)
+    DO i=1,src_ni
+      src_field_2D_clone(i) = src_field_2D(i)
+      IF ((23.5 * ts < src_lat(i)) .AND. (src_lat(i) < 65.5 *ts) .AND. (0 < src_lon(i)) .AND. (src_lon(i) < 30*ts)) THEN      
+        src_field_2D_clone(i) = missing_value    
+      ENDIF
+    ENDDO
+
+    CALL xios_send_field("src_field_2D_clone",src_field_2D_clone)
+    CALL xios_send_field("src_field_3D",src_field_3D)
+    CALL xios_send_field("src_field_3D_clone",src_field_3D)
+    CALL xios_send_field("src_field_4D",src_field_4D)
+    CALL xios_send_field("src_field_3D_pression",src_field_pression)
+ !   CALL xios_send_field("tmp_field_0",tmp_field_0)
+ !   CALL xios_send_field("tmp_field_1",tmp_field_1)
+ !   CALL xios_send_field("tmp_field_2",tmp_field_2)
     CALL wait_us(5000) ;
    ENDDO
@@ -254,5 +262,5 @@
   DEALLOCATE(src_lon, src_lat, src_boundslon,src_boundslat, src_field_2D)
   DEALLOCATE(dst_lon, dst_lat, dst_boundslon,dst_boundslat)
-  DEALLOCATE(tmp_field_0, tmp_field_1, tmp_field_2)
+  !DEALLOCATE(tmp_field_0, tmp_field_1, tmp_field_2)
   
   CALL xios_finalize()
Index: XIOS/dev/branch_yushan_merged/src/test/test_unstruct_omp.f90
===================================================================
--- XIOS/dev/branch_yushan_merged/src/test/test_unstruct_omp.f90	(revision 1196)
+++ XIOS/dev/branch_yushan_merged/src/test/test_unstruct_omp.f90	(revision 1203)
@@ -267,5 +267,5 @@
   CALL xios_finalize()
 
-print *, "Client : xios_finalize "
+print *, mpi_rank, "Client : xios_finalize "
 
   !$omp barrier